.code
IniciaODBC PROC
LOCAL BufferTMP[1024]:BYTE
LOCAL strFindData:WIN32_FIND_DATA
LOCAL SizeTMP:DWORD

	;Obtenemos un entorno ODBC
	invoke SQLAllocHandle,SQL_HANDLE_ENV,SQL_NULL_HANDLE,ADDR hEntornoODBC
	.if ax!=SQL_SUCCESS
		invoke MuestraErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_ENV,hEntornoODBC
		jmp IniciaODBC_FinError
	.endif
	
	;Comprobamos que la version ODBC es superior a la 2
	invoke SQLSetEnvAttr,hEntornoODBC,SQL_ATTR_ODBC_VERSION,SQL_OV_ODBC3,0
	.if ax!=SQL_SUCCESS	
		invoke MuestraErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_ENV,hEntornoODBC
		jmp IniciaODBC_FinError
	.endif
	
	;Comprobamos si existe la base de datos deseada
	invoke FindFirstFile,ADDR FicheroBaseDatos,ADDR strFindData
	.if eax==INVALID_HANDLE_VALUE
		;Si no existe, lo indicamos
		mov	boolExisteBaseDatos,FALSE
		invoke MessageBox,NULL,ADDR txtNoExiste,ADDR lblNoExiste,MB_ICONINFORMATION
	.else
		;Si existe, cerramos la busqueda
		mov boolExisteBaseDatos,TRUE
		invoke FindClose,eax
	.endif
	 
	;Obtenemos un HANDLE para la conexion
	invoke SQLAllocHandle,SQL_HANDLE_DBC,hEntornoODBC,ADDR hConexionODBC
	.if ax!=SQL_SUCCESS
		invoke MuestraErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_DBC,hConexionODBC
		jmp IniciaODBC_FinError
	.endif
	
	;Abrimos la conexion ODBC. Si no existia la base de datos, la creara 
	invoke SQLDriverConnect,hConexionODBC,NULL,ADDR CadenaODBC,sizeof CadenaODBC,ADDR BufferTMP,1,ADDR SizeTMP,SQL_DRIVER_COMPLETE
	.if ax!=(SQL_SUCCESS or SQL_SUCCESS_WITH_INFO)
		invoke MuestraErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_DBC,hConexionODBC
		jmp IniciaODBC_FinError
	.endif
	
	;Si no existia, creamos la estructura de tablas y campos
	.if boolExisteBaseDatos==FALSE
		invoke CrearEstructura
	.else
		;Si existe, comprobamos su estructura y en caso de no ser la correcta, la actualizamos
		invoke ComprobarEstructura
		.if eax!=0
			;invoke ActualizarEstructura
		.endif
	.endif

	Ret
IniciaODBC_FinError:
	mov ErrorGordo, TRUE
	Ret
IniciaODBC EndP
FinalizaODBC PROC
	
	.if hConexionODBC!=0
		invoke	SQLDisconnect,hConexionODBC
		invoke	SQLFreeHandle,SQL_HANDLE_DBC,hConexionODBC
	.endif
	.if hEntornoODBC!=0
		invoke	SQLFreeHandle,SQL_HANDLE_ENV,hEntornoODBC
	.endif
	Ret
FinalizaODBC EndP
CrearEstructura PROC
LOCAL BufferTMP[8192]:BYTE
LOCAL BufferTMP2[8192]:BYTE
LOCAL IndiceTMP:DWORD
LOCAL LongitudTMP:DWORD

	;Obtenemos un estamento para crear el contenido de tablas y campos mediante SQL
	invoke SQLAllocHandle,SQL_HANDLE_STMT,hConexionODBC,ADDR hEstamento_1_ODBC
	.if ax!=SQL_SUCCESS
		invoke MuestraErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_STMT,hEstamento_1_ODBC
		jmp CrearEstructura_FinError
	.endif
	
;Chapuzas Varias
	mov IndiceTMP,0
	invoke szLen,ADDR TablasACrear
	mov LongitudTMP, eax
	inc eax
	.while eax!=LongitudTMP
		inc IndiceTMP
		invoke InString,IndiceTMP,ADDR TablasACrear,ADDR cnstPuntoYComa
		push eax
		dec IndiceTMP
		sub eax, IndiceTMP
		invoke szMid,ADDR TablasACrear,ADDR BufferTMP,IndiceTMP,eax
		pop eax
		mov IndiceTMP,eax
	
		;Creamos la tabla. (La primera ha de ser la tabla BackupSQLs)
		;Se guarda un copia de las SQL "generadoras" en la tabla BackupSQLs
		invoke SQLExecDirect,hEstamento_1_ODBC,ADDR BufferTMP,SQL_NTS
		.if !((ax==SQL_SUCCESS) || (ax==SQL_SUCCESS_WITH_INFO))
			invoke MuestraErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_STMT,hEstamento_1_ODBC
			jmp CrearEstructura_FinError
		.endif
		;Y guardamos la SQL
		invoke wsprintf,ADDR BufferTMP2,ADDR fmtEscribeCampo,ADDR BufferTMP
		invoke SQLExecDirect,hEstamento_1_ODBC,ADDR BufferTMP2,SQL_NTS
		.if !((ax==SQL_SUCCESS) || (ax==SQL_SUCCESS_WITH_INFO))
			invoke MuestraErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_STMT,hEstamento_1_ODBC
			jmp CrearEstructura_FinError
		.endif
		mov eax, IndiceTMP
	.endw	
	
	;Liberamos el estamento
	.if hEstamento_1_ODBC!=0
		invoke SQLFreeStmt,hEstamento_1_ODBC,SQL_UNBIND or SQL_CLOSE
		invoke SQLFreeHandle,SQL_HANDLE_STMT,hEstamento_1_ODBC
	.endif
	
	invoke MessageBox,NULL,ADDR txtCreada,ADDR lblNoExiste,MB_ICONINFORMATION
	Ret
CrearEstructura_FinError:
	mov ErrorGordo,TRUE
	Ret
CrearEstructura EndP
ComprobarEstructura PROC
LOCAL ConsultaTMP[1024]:BYTE
LOCAL ResultadoTMP[1024]:BYTE
LOCAL CadenaTMP[1024]:BYTE
LOCAL PosicionTMP:DWORD

	;Obtenemos un estamento para crear el contenido de tablas y campos mediante SQL
	invoke SQLAllocHandle,SQL_HANDLE_STMT,hConexionODBC,ADDR hEstamento_1_ODBC
	.if ax!=SQL_SUCCESS
		invoke MuestraErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_STMT,hEstamento_1_ODBC
		jmp ComprobarEstructura_FinError
	.endif
	
	; para que funcione correctamente SQLFetchScroll
	;invoke SQLSetStmtAttr,hEstamento_1_ODBC,SQL_ATTR_CURSOR_TYPE,SQL_CURSOR_DYNAMIC,0

	;Obtener el nombre de la tabla principal (la primera de la lista)
	mov PosicionCadenaGeneratrizSQL,offset TablasACrear
	invoke ExtraerSQLGeneratriz
	invoke ExtraerNombreTabla
	;Creamos una consulta para ver si existe esa primera tabla 
	invoke wsprintf,ADDR ConsultaTMP,ADDR fmtConsultaSQL_Tablas,ADDR NombreTabla
	;Realizamos una SQL
	invoke SQLExecDirect,hEstamento_1_ODBC,ADDR ConsultaTMP,SQL_NTS
	.if !((ax==SQL_SUCCESS) || (ax==SQL_SUCCESS_WITH_INFO))
		invoke MuestraErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_STMT,hEstamento_1_ODBC
		jmp ComprobarEstructura_FinError
	.else
		;Comprobamos si se han obtenido resultados
		invoke SQLNumResultCols,hEstamento_1_ODBC,ADDR NumColumnasObtenidas
		.if NumColumnasObtenidas>0
			;Como solo se ha consultado la existencia de esa primera tabla, si estamos aqui
			; siginifica que existe
			;Cerramos el cursor de datos
			invoke SQLCloseCursor,hEstamento_1_ODBC

			;Ahora se trata de comparar las tablas que existen con las que hay en el programa
			;Por depronto ya tenemos el nombre de la tabla que alberga las SQLs
			mov PosicionCadenaGeneratrizSQL,offset TablasACrear
			mov ebx, PosicionCadenaGeneratrizSQL
			;El bucle comprobara si las tablas que necesita el programa estan en la base de datos
			.while byte ptr [ebx]!=0
				;Leemos una cadena SQL de las que generaria el programa
				invoke ExtraerSQLGeneratriz
				invoke wsprintf,ADDR ConsultaTMP,ADDR fmtCamposDeLaTabla,ADDR NombreTabla,ADDR cnstSQLS,ADDR CadenaGeneratrizSQL
				;Realizamos la consulta
				invoke SQLExecDirect,hEstamento_1_ODBC,ADDR ConsultaTMP,SQL_NTS
				.if !((ax==SQL_SUCCESS) || (ax==SQL_SUCCESS_WITH_INFO))
					invoke MuestraErrorODBC,ADDR idbasededatos,@Line-2,SQL_HANDLE_STMT,hEstamento_1_ODBC
					jmp ComprobarEstructura_FinError
				.else
					;Este SQLNumResulCols no veo que funcione solo para saber si esta o no en la base de datos
					invoke SQLNumResultCols,hEstamento_1_ODBC,ADDR NumColumnasObtenidas
					.if NumColumnasObtenidas>0
						;Por lo que obtenemos los resultados de la SQL 
						invoke SQLBindCol,hEstamento_1_ODBC,1,SQL_C_CHAR,ADDR ResultadoTMP,sizeof ResultadoTMP,ADDR NumColumnasObtenidas
						;Y los comprobamos
						invoke szLen,ADDR CadenaGeneratrizSQL
						invoke szCmpi,ADDR ResultadoTMP,ADDR CadenaGeneratrizSQL,eax
						;Si falla la comparacion, salimos directamente. Es necesaria una actualizacion de la base de datos
						.break.if eax!=0
					.endif
				.endif
				;Cerramos el cursor con cada consulta. Esto no se si es necesario, pero por si acaso
				invoke SQLCloseCursor,hEstamento_1_ODBC
				mov ebx, PosicionCadenaGeneratrizSQL
				mov al, byte ptr [ebx]
			.endw
		.elseif
			;Si resulta que no existe la tabla principal, pero si la base de datos... AVISAR
			invoke MessageBox,NULL,ADDR txtErrorTablaPrincipal,NULL,MB_ICONERROR
			jmp ComprobarEstructura_FinError
		.endif
	.endif
	;Si la estructura es la correcta, lo indicamos como devolucion en eax
	mov eax,TRUE
ComprobarEstructura_Fin:
	push eax
	;Liberamos el estamento
	.if hEstamento_1_ODBC!=0
		invoke	SQLFreeHandle,SQL_HANDLE_STMT,hEstamento_1_ODBC
	.endif
	pop eax
	Ret
ComprobarEstructura_FinError:
	;Si falta alguna tabla o es distinta, avisamos para poder actualizar la tabla
	mov eax,FALSE
	jmp ComprobarEstructura_Fin
ComprobarEstructura EndP
ExtraerSQLGeneratriz PROC uses ebx
LOCAL IndiceLocal:DWORD
	
	invoke InString,1,PosicionCadenaGeneratrizSQL,ADDR cnstPuntoYComa
	push eax
	invoke szMid,PosicionCadenaGeneratrizSQL,ADDR CadenaGeneratrizSQL,0,eax
	pop eax

	add PosicionCadenaGeneratrizSQL, eax
	Ret
ExtraerSQLGeneratriz EndP
ExtraerNombreTabla PROC

	invoke InString,14,ADDR CadenaGeneratrizSQL,ADDR cnstEspacio
	sub eax, 14
	push eax
	invoke szMid,ADDR CadenaGeneratrizSQL,ADDR NombreTabla,13,eax
	pop eax
	Ret
ExtraerNombreTabla EndP
ActualizarEstructura PROC

	Ret
ActualizarEstructura EndP
MuestraErrorODBC proc Fichero:DWORD,Linea:DWORD,Tipo:DWORD,HandleODBC:DWORD
LOCAL BufferTMP[1024]:BYTE
LOCAL BufferTMP2[1024]:BYTE
LOCAL TipoMsg:DWORD
	
	invoke SQLGetDiagField,Tipo,HandleODBC,1,SQL_DIAG_MESSAGE_TEXT,ADDR BufferTMP,sizeof BufferTMP,ADDR Leidos
	.if ax == SQL_SUCCESS_WITH_INFO
		mov TipoMsg,MB_ICONEXCLAMATION or MB_OK
	.else
		mov TipoMsg,MB_ICONERROR or MB_OK
	.endif
	invoke wsprintf,ADDR BufferTMP2,ADDR fmtMuestraErrorODBC,Fichero,Linea,ADDR BufferTMP
	invoke MessageBox,NULL,ADDR BufferTMP2,NULL,TipoMsg
	mov eax,1
	RET
MuestraErrorODBC EndP
